﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HEVC_CABAC_Verification_Tool
{
    class Binarizer
    {
        public List<Syntax_element> Binarize(Int16[,] TB)
        {
            List<Syntax_element> Binarized = new List<Syntax_element>();

            Int16[] TBDiagonal = {  TB[3, 3], TB[3, 2], TB[2, 3], TB[3, 1],
                                    TB[2, 2], TB[1, 3], TB[3, 0], TB[2, 1],
                                    TB[1, 2], TB[0, 3], TB[2, 0], TB[1, 1],
                                    TB[0, 2], TB[1, 0], TB[0, 1], TB[0, 0]  };

            uint[] Sig_coeff_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            char[] Sig_coeff_flag_writeout = "XXXXXXXXXXXXXXXXXXX".ToCharArray();
            int Sig_coeff_flag_index = 0;
            bool Sig_coeff_flag_First_Found = false;

            uint[] coeff_abs_level_greater1_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            char[] coeff_abs_level_greater1_flag_writeout = "XXXXXXXXXXX".ToCharArray();
            int coeff_abs_level_greater1_flag_index = 0;
            int coeff_abs_level_greater1_MaxIndex = 0;
            bool coeff_abs_level_greater1_flag_First_Found = false;

            uint[] coeff_abs_level_greater2_flag = { 0 };
            char[] coeff_abs_level_greater2_flag_writeout = "XXX".ToCharArray();
            bool coeff_abs_level_greater2_flag_First_Found = false;

            uint[] Sig_Plus_ALG1_Plus_ALG2 = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

            uint[] coeff_sign_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            char[] coeff_sign_flag_writeout = "XXXXXXXXXXXXXXXXXXX".ToCharArray();
            int coeff_sign_flag_index = 0;


            Binarize_sig_coeff_flag(TBDiagonal);

            return Binarized;
        }

        private Syntax_element Binarize_sig_coeff_flag(Int16[] TB)
        {
            Syntax_element sig_coeff_flag = new Syntax_element();
            bool Sig_coeff_flag_First_Found = false;



            for (int i = 0; i < 16; i++)
            {
                if (TB[i] != 0 && Sig_coeff_flag_First_Found == false)
                {
                    Sig_coeff_flag_First_Found = true;
                    MessageBox.Show("HERE2:" + new string(sig_coeff_flag.Bins.ToArray()));
                }
                else
                {
                    if (TB[i] != 0)
                    {
                        sig_coeff_flag.Bins.Add('1');
                    }
                    else
                    {
                        sig_coeff_flag.Bins.Add('0');
                    }
                }
            }

            MessageBox.Show("HERE:" + new string(sig_coeff_flag.Bins.ToArray()));
            return sig_coeff_flag;
        }
    }
}
